@ECHO OFF

SET pshell=powershell
WHERE /Q %pshell%
IF NOT ERRORLEVEL 1 GOTO havepshell
SET pshell=%SYSTEMROOT%\System32\WindowsPowerShell\v1.0\powershell
IF EXIST %pshell%.exe GOTO havepshell
ECHO ERROR: PowerShell is needed for this batch file, but it cannot be detected
ECHO        on your system (it should be preinstalled on Windows 10 since version
ECHO        1607). You should either check your Windows installation or go to this
ECHO        Microsoft page and install PowerShell yourself:
ECHO        https://tinyurl.com/y85wsdr4
ECHO(
GOTO abort

:havepshell
IF "%1"=="as_admin" GOTO isadmin
FOR /F "tokens=* USEBACKQ" %%F IN (`%pshell% "[Environment]::GetFolderPath('Personal')"`) DO SET doc=%%F\
FOR /F "tokens=* USEBACKQ" %%F IN (`%pshell% "(new-object -COM Shell.Application).Namespace(0x05).Self.Path"`) DO SET doc1=%%F\
SET "doc2=%USERPROFILE%\Documents\"
IF "%doc1%"=="\" SET "doc1=%doc2%"
IF "%doc%"=="\" SET "doc=%doc1%"
SET "loc=%LOCALAPPDATA%"
SET "app=%APPDATA%"
SET "usrprf=%USERPROFILE%"

IF NOT EXIST RealRepo\elevate.exe GOTO badextract
RealRepo\elevate -c %0 as_admin "%doc%" "%doc1%" "%doc2%" "%loc%" "%app%" "%usrprf%"
IF NOT ERRORLEVEL 1 GOTO exitnow
ECHO ERROR: The installer needs administrative privileges to complete. Please
ECHO        make sure to answer Yes at the User Account Control (UAC) prompt.
ECHO        After the installation completes successfully, it will no longer
ECHO        be necessary to run the game or the mod as admin.
ECHO(
GOTO abort

:isadmin
SET doc=%2
SET doc1=%3
SET doc2=%4
SET loc=%5
SET app=%6
SET usrprf=%7
SET "doc=%doc:"=%"
SET "doc1=%doc1:"=%"
SET "doc2=%doc2:"=%"
SET "loc=%loc:"=%"
SET "app=%app:"=%"
SET "usrprf=%usrprf:"=%"

SET base=%~dp0
CD /D %base%

IF EXIST RealRepo GOTO haverepo
:badextract
ECHO ERROR: Mod installation files not found. When unzipping the mod archive,
ECHO        please make sure to overwrite existing files and to use folder
ECHO        names (preserve the zip folder structure).
ECHO(
GOTO abort

:haverepo
IF NOT EXIST RealVR*.ini GOTO noini
ECHO R.E.A.L. VR settings were found in the game folder,
ECHO presumably from a previous installation of the mod.
CHOICE /C KD /M "Do you want to (K)eep or (D)elete them?"
IF ERRORLEVEL 3 GOTO abort
IF NOT ERRORLEVEL 1 GOTO abort
IF ERRORLEVEL 2 DEL /F /Q RealVR*.ini
ECHO(
ECHO(

:noini
IF EXIST HorizonZeroDawn.exe GOTO installHZD
IF EXIST Cyberpunk2077.exe GOTO installCP2077
IF EXIST eldenring.exe GOTO installELDEN
IF EXIST DarkSoulsRemastered.exe GOTO installDSR
IF EXIST ff7remake_.exe GOTO installFF7R
IF EXIST GWT.exe IF EXIST OpenImageDenoise.dll GOTO installGWT
IF EXIST GWT.exe IF EXIST XCurl.dll GOTO installGWT
IF EXIST Stray-Win64-Shipping.exe GOTO installSTRAY
IF EXIST Ghostrunner-Win64-Shipping.exe GOTO installGRHEL
IF EXIST Maine-Win*-Shipping.exe GOTO installGROUNDED
IF EXIST Spider-Man.exe GOTO installSPIDEY
IF EXIST MilesMorales.exe GOTO installSPIDEY
IF EXIST HogwartsLegacy.exe IF EXIST EOSSDK-Win64-Shipping.dll GOTO installHOGWARTS
IF EXIST Oregon-Win*-Shipping.exe GOTO installHOL
IF EXIST AtomicHeart-Win*-Shipping.exe GOTO installAH
IF EXIST u4.exe IF EXIST tll.exe GOTO installULOTC
ECHO ERROR: This folder does not seem to belong to any of the supported games.
ECHO        Please make sure that the mod zip archive is extracted to the very
ECHO        same folder where the main game executable is found, and not for
ECHO        example into a subfolder.
ECHO(
GOTO abort


:installHZD
ECHO ******************************************
ECHO * R.E.A.L. VR mod for Horizon: Zero Dawn *
ECHO ******************************************
ECHO(

ECHO Fixing folder permissions...
ICACLS . /GRANT *S-1-5-32-545:(OI)(CI)F /T /Q

ECHO Working around NVIDIA V-Sync bug...
RealRepo\Vdesync "%base%HorizonZeroDawn.exe"

ECHO Installing graphics settings preset...
SET sub=Horizon Zero Dawn\Saved Game\profile\
IF NOT EXIST "%doc%%sub%" IF EXIST "%doc1%%sub%" SET "doc=%doc1%"
IF NOT EXIST "%doc%%sub%" IF EXIST "%doc2%%sub%" SET "doc=%doc2%"
SET "dst=%doc%%sub%"
IF EXIST "%dst%" (
    IF EXIST "%dst%graphicsconfig.ini" (
        IF NOT EXIST "%dst%graphicsconfig_ori.ini" REN "%dst%graphicsconfig.ini" graphicsconfig_ori.ini
    ) ELSE (
        ECHO WARNING: Unable to find previous graphics settings file
        ECHO          "%dst%graphicsconfig.ini"
    )
) ELSE GOTO neverrun
COPY /Y "RealRepo\HZD\Settings\graphicsconfig.ini" "%dst%"

ECHO Copying game specific files...
COPY /Y RealRepo\RealVR64.dll dxgi.dll
IF NOT EXIST RealVR.ini COPY /Y RealRepo\RealVR.ini .

ECHO Cleaning up...
IF EXIST RealRepo\CP2077 RMDIR /S /Q RealRepo\CP2077
IF EXIST RealRepo\ELDEN RMDIR /S /Q RealRepo\ELDEN
IF EXIST RealRepo\DSR RMDIR /S /Q RealRepo\DSR
IF EXIST RealRepo\FF7R RMDIR /S /Q RealRepo\FF7R
IF EXIST RealRepo\GWT RMDIR /S /Q RealRepo\GWT
IF EXIST RealRepo\STRAY RMDIR /S /Q RealRepo\STRAY
IF EXIST RealRepo\GRHEL RMDIR /S /Q RealRepo\GRHEL
IF EXIST RealRepo\GROUNDED RMDIR /S /Q RealRepo\GROUNDED
IF EXIST RealRepo\SPIDEY RMDIR /S /Q RealRepo\SPIDEY
IF EXIST RealRepo\HOGWARTS RMDIR /S /Q RealRepo\HOGWARTS
IF EXIST RealRepo\HOL RMDIR /S /Q RealRepo\HOL
IF EXIST RealRepo\AH RMDIR /S /Q RealRepo\AH
IF EXIST RealRepo\ULOTC RMDIR /S /Q RealRepo\ULOTC
GOTO finish


:installCP2077
ECHO **************************************
ECHO * R.E.A.L. VR mod for Cyberpunk 2077 *
ECHO **************************************
ECHO(

ECHO Fixing folder permissions...
ICACLS . /GRANT *S-1-5-32-545:(OI)(CI)F /T /Q

ECHO Working around NVIDIA V-Sync bug...
RealRepo\Vdesync "%base%Cyberpunk2077.exe"

ECHO Installing graphics settings preset...
SET sub=\CD Projekt Red\Cyberpunk 2077\
SET "dst=%loc%%sub%"
IF EXIST "%dst%UserSettings.json" (
    IF NOT EXIST "%dst%UserSettings_ori.json" COPY /Y "%dst%UserSettings.json" "%dst%UserSettings_ori.json"
) ELSE GOTO neverrun
REN "%dst%UserSettings.json" UserSettings_src.json
RealRepo\ReplaceJSON "%dst%UserSettings_src.json" RealRepo\CP2077\Settings\option.replace "%dst%UserSettings.json"
DEL /F /Q "%dst%UserSettings_src.json"

ECHO Copying game specific files...
COPY /Y RealRepo\RealVR64.dll dxgi.dll
IF NOT EXIST RealVR.ini COPY /Y RealRepo\RealVR.ini .

ECHO Cleaning up...
IF EXIST RealRepo\HZD RMDIR /S /Q RealRepo\HZD
IF EXIST RealRepo\ELDEN RMDIR /S /Q RealRepo\ELDEN
IF EXIST RealRepo\DSR RMDIR /S /Q RealRepo\DSR
IF EXIST RealRepo\FF7R RMDIR /S /Q RealRepo\FF7R
IF EXIST RealRepo\GWT RMDIR /S /Q RealRepo\GWT
IF EXIST RealRepo\STRAY RMDIR /S /Q RealRepo\STRAY
IF EXIST RealRepo\GRHEL RMDIR /S /Q RealRepo\GRHEL
IF EXIST RealRepo\GROUNDED RMDIR /S /Q RealRepo\GROUNDED
IF EXIST RealRepo\SPIDEY RMDIR /S /Q RealRepo\SPIDEY
IF EXIST RealRepo\HOGWARTS RMDIR /S /Q RealRepo\HOGWARTS
IF EXIST RealRepo\HOL RMDIR /S /Q RealRepo\HOL
IF EXIST RealRepo\AH RMDIR /S /Q RealRepo\AH
IF EXIST RealRepo\ULOTC RMDIR /S /Q RealRepo\ULOTC
GOTO finish


:installELDEN
ECHO **********************************
ECHO * R.E.A.L. VR mod for Elden Ring *
ECHO **********************************
ECHO(
CHOICE /C UHML /M "Select (U)ltra, (H)igh, (M)edium or (L)ow config"
IF ERRORLEVEL 5 GOTO abort
IF NOT ERRORLEVEL 1 GOTO abort
IF ERRORLEVEL 1 SET cfg=1ultra
IF ERRORLEVEL 2 SET cfg=2high
IF ERRORLEVEL 3 SET cfg=3medium
IF ERRORLEVEL 4 SET cfg=4low

ECHO Fixing folder permissions...
ICACLS . /GRANT *S-1-5-32-545:(OI)(CI)F /T /Q

ECHO Working around NVIDIA V-Sync bug...
RealRepo\Vdesync "%base%eldenring.exe"

ECHO Installing graphics settings preset...
SET sub=\EldenRing\
SET "dst=%app%%sub%"
IF EXIST "%dst%GraphicsConfig.xml" (
    IF NOT EXIST "%dst%GraphicsConfig_ori.xml" COPY /Y "%dst%GraphicsConfig.xml" "%dst%GraphicsConfig_ori.xml"
) ELSE GOTO neverrun
COPY /Y "RealRepo\ELDEN\Settings\GraphicsConfig_%cfg%.xml" "%dst%GraphicsConfig.xml"

ECHO Copying game specific files...
COPY /Y RealRepo\ELDEN\BackupSaves.bat RealRepo
FOR /F "USEBACKQ" %%F IN ('start_protected_game.exe') DO SET filesize=%%~zF
if %filesize% GTR 1048576 (
    IF EXIST start_protected_game_ori.exe DEL /F /Q start_protected_game_ori.exe
    REN start_protected_game.exe start_protected_game_ori.exe
    COPY /Y RealRepo\ELDEN\start_protected_game.exe .
)
COPY /Y RealRepo\RealVR64.dll .
IF NOT EXIST RealVR.ini COPY /Y RealRepo\RealVR.ini .

ECHO Cleaning up...
IF EXIST RealRepo\HZD RMDIR /S /Q RealRepo\HZD
IF EXIST RealRepo\CP2077 RMDIR /S /Q RealRepo\CP2077
IF EXIST RealRepo\DSR RMDIR /S /Q RealRepo\DSR
IF EXIST RealRepo\FF7R RMDIR /S /Q RealRepo\FF7R
IF EXIST RealRepo\GWT RMDIR /S /Q RealRepo\GWT
IF EXIST RealRepo\STRAY RMDIR /S /Q RealRepo\STRAY
IF EXIST RealRepo\GRHEL RMDIR /S /Q RealRepo\GRHEL
IF EXIST RealRepo\GROUNDED RMDIR /S /Q RealRepo\GROUNDED
IF EXIST RealRepo\SPIDEY RMDIR /S /Q RealRepo\SPIDEY
IF EXIST RealRepo\HOGWARTS RMDIR /S /Q RealRepo\HOGWARTS
IF EXIST RealRepo\HOL RMDIR /S /Q RealRepo\HOL
IF EXIST RealRepo\AH RMDIR /S /Q RealRepo\AH
IF EXIST RealRepo\ULOTC RMDIR /S /Q RealRepo\ULOTC
GOTO finish


:installDSR
ECHO **********************************************
ECHO * R.E.A.L. VR mod for Dark Souls: Remastered *
ECHO **********************************************
ECHO(

ECHO WARNING: Online features for Dark Souls: Remastered have been reactivated.
ECHO          From initial testing, it appears that it's possible to play online
ECHO          with the VR mod. However that could be interpreted as cheating
ECHO          and/or violating the EULA, which might lead to your account being
ECHO          temporarily or even permanently banned.
ECHO          Playing in offline mode should be safe.
ECHO(
ECHO Neither the author of the R.E.A.L. VR mod nor Patreon can be held responsible
ECHO if anything happens to your account when playing the modded game. Enter the
ECHO word "Yes" without the quotes if you accept this and take full responsibility
ECHO for your actions, anything else to quit without changing the game installation.

SET /P accept=">: "
IF /I NOT %accept%==Yes GOTO abort

ECHO Fixing folder permissions...
ICACLS . /GRANT *S-1-5-32-545:(OI)(CI)F /T /Q

ECHO Working around NVIDIA V-Sync bug...
RealRepo\Vdesync "%base%DarkSoulsRemastered.exe"

ECHO Installing graphics settings preset...
SET sub=\FromSoftware\NBGI\DarkSouls\
SET "dst=%loc%%sub%"
IF EXIST "%dst%DarkSouls.ini" (
    IF NOT EXIST "%dst%DarkSouls_ori.ini" COPY /Y "%dst%DarkSouls.ini" "%dst%DarkSouls_ori.ini"
) ELSE GOTO neverrun
COPY /Y "RealRepo\DSR\Settings\DarkSouls.ini" "%dst%DarkSouls.ini"

ECHO Copying game specific files...
COPY /Y RealRepo\DSR\BackupSaves.bat RealRepo
COPY /Y RealRepo\RealVR64.dll dxgi.dll
IF NOT EXIST RealVR.ini COPY /Y RealRepo\RealVR.ini .

ECHO Cleaning up...
IF EXIST RealRepo\HZD RMDIR /S /Q RealRepo\HZD
IF EXIST RealRepo\CP2077 RMDIR /S /Q RealRepo\CP2077
IF EXIST RealRepo\ELDEN RMDIR /S /Q RealRepo\ELDEN
IF EXIST RealRepo\FF7R RMDIR /S /Q RealRepo\FF7R
IF EXIST RealRepo\GWT RMDIR /S /Q RealRepo\GWT
IF EXIST RealRepo\STRAY RMDIR /S /Q RealRepo\STRAY
IF EXIST RealRepo\GRHEL RMDIR /S /Q RealRepo\GRHEL
IF EXIST RealRepo\GROUNDED RMDIR /S /Q RealRepo\GROUNDED
IF EXIST RealRepo\SPIDEY RMDIR /S /Q RealRepo\SPIDEY
IF EXIST RealRepo\HOGWARTS RMDIR /S /Q RealRepo\HOGWARTS
IF EXIST RealRepo\HOL RMDIR /S /Q RealRepo\HOL
IF EXIST RealRepo\AH RMDIR /S /Q RealRepo\AH
IF EXIST RealRepo\ULOTC RMDIR /S /Q RealRepo\ULOTC
GOTO finish


:installFF7R
ECHO ***********************************************************
ECHO * R.E.A.L. VR mod for Final Fantasy VII Remake Intergrade *
ECHO ***********************************************************

ECHO Fixing folder permissions...
ICACLS . /GRANT *S-1-5-32-545:(OI)(CI)F /T /Q

ECHO Working around NVIDIA V-Sync bug...
RealRepo\Vdesync "%base%ff7remake_.exe"

ECHO Installing graphics settings preset...
SET sub=My Games\FINAL FANTASY VII REMAKE\
IF NOT EXIST "%doc%%sub%" IF EXIST "%doc1%%sub%" SET "doc=%doc1%"
IF NOT EXIST "%doc%%sub%" IF EXIST "%doc2%%sub%" SET "doc=%doc2%"
SET "dst=%doc%%sub%"
SET haveprofile=no
IF NOT EXIST "%dst%" GOTO checkFF7Rprofile
FOR /F "delims=" %%D IN ('DIR /AD /B "%dst%EOS"') DO (
    COPY /Y "RealRepo\FF7R\Settings\ff7remakedevice.sav" "%dst%EOS\%%D"
    SET haveprofile=yes
)
FOR /F "delims=" %%D IN ('DIR /AD /B "%dst%Steam"') DO (
    COPY /Y "RealRepo\FF7R\Settings\ff7remakedevice.sav" "%dst%Steam\%%D"
    SET haveprofile=yes
)
:checkFF7Rprofile
IF %haveprofile%==no GOTO neverrun
SET "wne=%dst%Saved\Config\WindowsNoEditor\"
MKDIR "%wne%"
IF NOT EXIST "%wne%Engine_ori.ini" COPY /Y "%wne%Engine.ini" "%wne%Engine_ori.ini"
COPY /Y "RealRepo\FF7R\Settings\Engine.ini" "%wne%"

ECHO Copying game specific files...
COPY /Y RealRepo\RealVR64.dll dxgi.dll
IF NOT EXIST RealVR.ini COPY /Y RealRepo\RealVR.ini .

ECHO Cleaning up...
IF EXIST RealRepo\HZD RMDIR /S /Q RealRepo\HZD
IF EXIST RealRepo\CP2077 RMDIR /S /Q RealRepo\CP2077
IF EXIST RealRepo\ELDEN RMDIR /S /Q RealRepo\ELDEN
IF EXIST RealRepo\DSR RMDIR /S /Q RealRepo\DSR
IF EXIST RealRepo\GWT RMDIR /S /Q RealRepo\GWT
IF EXIST RealRepo\STRAY RMDIR /S /Q RealRepo\STRAY
IF EXIST RealRepo\GRHEL RMDIR /S /Q RealRepo\GRHEL
IF EXIST RealRepo\GROUNDED RMDIR /S /Q RealRepo\GROUNDED
IF EXIST RealRepo\SPIDEY RMDIR /S /Q RealRepo\SPIDEY
IF EXIST RealRepo\HOGWARTS RMDIR /S /Q RealRepo\HOGWARTS
IF EXIST RealRepo\HOL RMDIR /S /Q RealRepo\HOL
IF EXIST RealRepo\AH RMDIR /S /Q RealRepo\AH
IF EXIST RealRepo\ULOTC RMDIR /S /Q RealRepo\ULOTC
GOTO finish


:installGWT
ECHO ****************************************
ECHO * R.E.A.L. VR mod for Ghostwire: Tokyo *
ECHO ****************************************

ECHO Fixing folder permissions...
ICACLS . /GRANT *S-1-5-32-545:(OI)(CI)F /T /Q

ECHO Working around NVIDIA V-Sync bug...
RealRepo\Vdesync "%base%GWT.exe"

ECHO Installing graphics settings preset...
SET sub=\Saved Games\TangoGameworks\
SET "dst=%usrprf%%sub%"
SET haveprofile=no
IF NOT EXIST "%dst%" GOTO neverrun
SET "wne=\Saved\Config\WindowsNoEditor\"
FOR /F "delims=" %%D IN ('DIR /AD /B "%dst%"') DO (
    IF NOT EXIST "%dst%%%D%wne%GameUserSettings_ori.ini" COPY /Y "%dst%%%D%wne%GameUserSettings.ini" "%dst%%%D%wne%GameUserSettings_ori.ini"
    COPY /Y "RealRepo\GWT\Settings\GameUserSettings.ini" "%dst%%%D%wne%"
    SET haveprofile=yes
)
:checkGWTprofile
IF %haveprofile%==no GOTO neverrun

ECHO Copying game specific files...
COPY /Y RealRepo\RealVR64.dll dxgi.dll
XCOPY /E /I /Q /Y RealRepo\GWT\reshade .
IF NOT EXIST RealVR.ini COPY /Y RealRepo\GWT\RealVR.ini .

ECHO Cleaning up...
IF EXIST RealRepo\HZD RMDIR /S /Q RealRepo\HZD
IF EXIST RealRepo\CP2077 RMDIR /S /Q RealRepo\CP2077
IF EXIST RealRepo\ELDEN RMDIR /S /Q RealRepo\ELDEN
IF EXIST RealRepo\DSR RMDIR /S /Q RealRepo\DSR
IF EXIST RealRepo\FF7R RMDIR /S /Q RealRepo\FF7R
IF EXIST RealRepo\STRAY RMDIR /S /Q RealRepo\STRAY
IF EXIST RealRepo\GRHEL RMDIR /S /Q RealRepo\GRHEL
IF EXIST RealRepo\GROUNDED RMDIR /S /Q RealRepo\GROUNDED
IF EXIST RealRepo\SPIDEY RMDIR /S /Q RealRepo\SPIDEY
IF EXIST RealRepo\HOGWARTS RMDIR /S /Q RealRepo\HOGWARTS
IF EXIST RealRepo\HOL RMDIR /S /Q RealRepo\HOL
IF EXIST RealRepo\AH RMDIR /S /Q RealRepo\AH
IF EXIST RealRepo\ULOTC RMDIR /S /Q RealRepo\ULOTC
GOTO finish


:installSTRAY
ECHO *****************************
ECHO * R.E.A.L. VR mod for Stray *
ECHO *****************************

ECHO Fixing folder permissions...
ICACLS . /GRANT *S-1-5-32-545:(OI)(CI)F /T /Q

ECHO Working around NVIDIA V-Sync bug...
RealRepo\Vdesync "%base%Stray-Win64-Shipping.exe"

ECHO Installing graphics settings preset...
SET sub=\Hk_project\Saved\Config\WindowsNoEditor\
SET "dst=%loc%%sub%"
IF NOT EXIST "%dst%" GOTO neverrun
IF NOT EXIST "%dst%GameUserSettings_ori.ini" COPY /Y "%dst%GameUserSettings.ini" "%dst%GameUserSettings_ori.ini"
COPY /Y "RealRepo\STRAY\Settings\GameUserSettings.ini" "%dst%"

ECHO Copying game specific files...
COPY /Y RealRepo\RealVR64.dll dxgi.dll

ECHO Cleaning up...
IF EXIST RealRepo\HZD RMDIR /S /Q RealRepo\HZD
IF EXIST RealRepo\CP2077 RMDIR /S /Q RealRepo\CP2077
IF EXIST RealRepo\ELDEN RMDIR /S /Q RealRepo\ELDEN
IF EXIST RealRepo\DSR RMDIR /S /Q RealRepo\DSR
IF EXIST RealRepo\FF7R RMDIR /S /Q RealRepo\FF7R
IF EXIST RealRepo\GWT RMDIR /S /Q RealRepo\GWT
IF EXIST RealRepo\GRHEL RMDIR /S /Q RealRepo\GRHEL
IF EXIST RealRepo\GROUNDED RMDIR /S /Q RealRepo\GROUNDED
IF EXIST RealRepo\SPIDEY RMDIR /S /Q RealRepo\SPIDEY
IF EXIST RealRepo\HOGWARTS RMDIR /S /Q RealRepo\HOGWARTS
IF EXIST RealRepo\HOL RMDIR /S /Q RealRepo\HOL
IF EXIST RealRepo\AH RMDIR /S /Q RealRepo\AH
IF EXIST RealRepo\ULOTC RMDIR /S /Q RealRepo\ULOTC
GOTO finish


:installGRHEL
ECHO *****************************************************
ECHO * R.E.A.L. VR mod for Ghostrunner: Complete Edition *
ECHO *****************************************************

ECHO Fixing folder permissions...
ICACLS . /GRANT *S-1-5-32-545:(OI)(CI)F /T /Q

ECHO Working around NVIDIA V-Sync bug...
RealRepo\Vdesync "%base%Ghostrunner-Win64-Shipping.exe"

ECHO Installing graphics settings preset...
SET sub=\Ghostrunner\Saved\Config\WindowsNoEditor\
SET "dst=%loc%%sub%"
IF NOT EXIST "%dst%" GOTO neverrun
IF NOT EXIST "%dst%GameUserSettings_ori.ini" COPY /Y "%dst%GameUserSettings.ini" "%dst%GameUserSettings_ori.ini"
COPY /Y "RealRepo\GRHEL\Settings\GameUserSettings.ini" "%dst%"

ECHO Copying game specific files...
COPY /Y RealRepo\RealVR64.dll dxgi.dll

ECHO Cleaning up...
IF EXIST RealRepo\HZD RMDIR /S /Q RealRepo\HZD
IF EXIST RealRepo\CP2077 RMDIR /S /Q RealRepo\CP2077
IF EXIST RealRepo\ELDEN RMDIR /S /Q RealRepo\ELDEN
IF EXIST RealRepo\DSR RMDIR /S /Q RealRepo\DSR
IF EXIST RealRepo\FF7R RMDIR /S /Q RealRepo\FF7R
IF EXIST RealRepo\GWT RMDIR /S /Q RealRepo\GWT
IF EXIST RealRepo\STRAY RMDIR /S /Q RealRepo\STRAY
IF EXIST RealRepo\GROUNDED RMDIR /S /Q RealRepo\GROUNDED
IF EXIST RealRepo\SPIDEY RMDIR /S /Q RealRepo\SPIDEY
IF EXIST RealRepo\HOGWARTS RMDIR /S /Q RealRepo\HOGWARTS
IF EXIST RealRepo\HOL RMDIR /S /Q RealRepo\HOL
IF EXIST RealRepo\AH RMDIR /S /Q RealRepo\AH
IF EXIST RealRepo\ULOTC RMDIR /S /Q RealRepo\ULOTC
GOTO finish


:installGROUNDED
ECHO ********************************
ECHO * R.E.A.L. VR mod for Grounded *
ECHO ********************************

ECHO Fixing folder permissions... (note: for the PC Game Pass version, getting an
ECHO Access Denied error that makes processing fail for 1 file is normal here)
ICACLS . /GRANT *S-1-5-32-545:(OI)(CI)F /T /Q

ECHO Working around NVIDIA V-Sync bug...
RealRepo\Vdesync "%base%Maine-Win64-Shipping.exe"
RealRepo\Vdesync "%base%Maine-WinGDK-Shipping.exe"

ECHO Installing graphics settings preset...
SET sub=\Maine\Saved\Config\WindowsNoEditor\
SET subGDK=\Maine\Saved\Config\WinGDK\
SET "dst=%loc%%sub%"
SET "dstGDK=%loc%%subGDK%"
IF NOT EXIST "%dst%" IF NOT EXIST "%dstGDK%" GOTO neverrun
IF EXIST "%dst%" (
    IF NOT EXIST "%dst%GameUserSettings_ori.ini" COPY /Y "%dst%GameUserSettings.ini" "%dst%GameUserSettings_ori.ini"
    COPY /Y "RealRepo\GROUNDED\Settings\GameUserSettings.ini" "%dst%"
)
IF EXIST "%dstGDK%" (
    IF NOT EXIST "%dstGDK%GameUserSettings_ori.ini" COPY /Y "%dstGDK%GameUserSettings.ini" "%dstGDK%GameUserSettings_ori.ini"
    COPY /Y "RealRepo\GROUNDED\Settings\GameUserSettings.ini" "%dstGDK%"
)

ECHO Copying game specific files...
COPY /Y RealRepo\RealVR64.dll dxgi.dll

ECHO Cleaning up...
IF EXIST RealRepo\HZD RMDIR /S /Q RealRepo\HZD
IF EXIST RealRepo\CP2077 RMDIR /S /Q RealRepo\CP2077
IF EXIST RealRepo\ELDEN RMDIR /S /Q RealRepo\ELDEN
IF EXIST RealRepo\DSR RMDIR /S /Q RealRepo\DSR
IF EXIST RealRepo\FF7R RMDIR /S /Q RealRepo\FF7R
IF EXIST RealRepo\GWT RMDIR /S /Q RealRepo\GWT
IF EXIST RealRepo\STRAY RMDIR /S /Q RealRepo\STRAY
IF EXIST RealRepo\GRHEL RMDIR /S /Q RealRepo\GRHEL
IF EXIST RealRepo\SPIDEY RMDIR /S /Q RealRepo\SPIDEY
IF EXIST RealRepo\HOGWARTS RMDIR /S /Q RealRepo\HOGWARTS
IF EXIST RealRepo\HOL RMDIR /S /Q RealRepo\HOL
IF EXIST RealRepo\AH RMDIR /S /Q RealRepo\AH
IF EXIST RealRepo\ULOTC RMDIR /S /Q RealRepo\ULOTC
GOTO finish


:installSPIDEY
ECHO ******************************************************
ECHO * R.E.A.L. VR mod for Marvel's Spider-Man Remastered *
ECHO *       and Marvel's Spider-Man: Miles Morales       *
ECHO ******************************************************

ECHO Fixing folder permissions...
ICACLS . /GRANT *S-1-5-32-545:(OI)(CI)F /T /Q

ECHO Working around NVIDIA V-Sync bug...
RealRepo\Vdesync "%base%Spider-Man.exe"
RealRepo\Vdesync "%base%MilesMorales.exe"

ECHO Copying game specific files...
COPY /Y RealRepo\RealVR64.dll dxgi.dll

ECHO Cleaning up...
IF EXIST RealRepo\HZD RMDIR /S /Q RealRepo\HZD
IF EXIST RealRepo\CP2077 RMDIR /S /Q RealRepo\CP2077
IF EXIST RealRepo\ELDEN RMDIR /S /Q RealRepo\ELDEN
IF EXIST RealRepo\DSR RMDIR /S /Q RealRepo\DSR
IF EXIST RealRepo\FF7R RMDIR /S /Q RealRepo\FF7R
IF EXIST RealRepo\GWT RMDIR /S /Q RealRepo\GWT
IF EXIST RealRepo\STRAY RMDIR /S /Q RealRepo\STRAY
IF EXIST RealRepo\GRHEL RMDIR /S /Q RealRepo\GRHEL
IF EXIST RealRepo\GROUNDED RMDIR /S /Q RealRepo\GROUNDED
IF EXIST RealRepo\HOGWARTS RMDIR /S /Q RealRepo\HOGWARTS
IF EXIST RealRepo\HOL RMDIR /S /Q RealRepo\HOL
IF EXIST RealRepo\AH RMDIR /S /Q RealRepo\AH
IF EXIST RealRepo\ULOTC RMDIR /S /Q RealRepo\ULOTC
GOTO finish


:installHOGWARTS
ECHO ***************************************
ECHO * R.E.A.L. VR mod for Hogwarts Legacy *
ECHO ***************************************

ECHO Fixing folder permissions...
ICACLS . /GRANT *S-1-5-32-545:(OI)(CI)F /T /Q

ECHO Working around NVIDIA V-Sync bug...
RealRepo\Vdesync "%base%HogwartsLegacy.exe"

ECHO Installing graphics settings preset...
SET sub=\Hogwarts Legacy\Saved\Config\WindowsNoEditor\
SET "dst=%loc%%sub%"
IF NOT EXIST "%dst%" GOTO neverrun
IF NOT EXIST "%dst%GameUserSettings_ori.ini" COPY /Y "%dst%GameUserSettings.ini" "%dst%GameUserSettings_ori.ini"
COPY /Y "RealRepo\HOGWARTS\Settings\GameUserSettings.ini" "%dst%"

ECHO Copying game specific files...
COPY /Y RealRepo\RealVR64.dll dxgi.dll

ECHO Cleaning up...
IF EXIST RealRepo\HZD RMDIR /S /Q RealRepo\HZD
IF EXIST RealRepo\CP2077 RMDIR /S /Q RealRepo\CP2077
IF EXIST RealRepo\ELDEN RMDIR /S /Q RealRepo\ELDEN
IF EXIST RealRepo\DSR RMDIR /S /Q RealRepo\DSR
IF EXIST RealRepo\FF7R RMDIR /S /Q RealRepo\FF7R
IF EXIST RealRepo\GWT RMDIR /S /Q RealRepo\GWT
IF EXIST RealRepo\STRAY RMDIR /S /Q RealRepo\STRAY
IF EXIST RealRepo\GRHEL RMDIR /S /Q RealRepo\GRHEL
IF EXIST RealRepo\GROUNDED RMDIR /S /Q RealRepo\GROUNDED
IF EXIST RealRepo\SPIDEY RMDIR /S /Q RealRepo\SPIDEY
IF EXIST RealRepo\HOL RMDIR /S /Q RealRepo\HOL
IF EXIST RealRepo\AH RMDIR /S /Q RealRepo\AH
IF EXIST RealRepo\ULOTC RMDIR /S /Q RealRepo\ULOTC
GOTO finish


:installHOL
ECHO ************************************
ECHO * R.E.A.L. VR mod for High On Life *
ECHO ************************************

ECHO Fixing folder permissions... (note: for the PC Game Pass version, getting an
ECHO Access Denied error that makes processing fail for 1 file is normal here)
ICACLS . /GRANT *S-1-5-32-545:(OI)(CI)F /T /Q

ECHO Removing conflicting VR hook...
DEL /F /Q ..\..\..\Engine\Binaries\ThirdParty\OpenXR\win64\openxr_loader.dll

ECHO Working around NVIDIA V-Sync bug...
RealRepo\Vdesync "%base%Oregon-Win64-Shipping.exe"
RealRepo\Vdesync "%base%Oregon-WinGDK-Shipping.exe"

ECHO Installing graphics settings preset...
SET sub=\Oregon\Saved\Config\WindowsNoEditor\
SET subGDK=\Oregon\Saved\Config\WinGDK\
SET "dst=%loc%%sub%"
SET "dstGDK=%loc%%subGDK%"
IF NOT EXIST "%dst%" IF NOT EXIST "%dstGDK%" GOTO neverrun
IF EXIST "%dst%" (
    IF NOT EXIST "%dst%GameUserSettings_ori.ini" COPY /Y "%dst%GameUserSettings.ini" "%dst%GameUserSettings_ori.ini"
    COPY /Y "RealRepo\HOL\Settings\GameUserSettings.ini" "%dst%"
)
IF EXIST "%dstGDK%" (
    IF NOT EXIST "%dstGDK%GameUserSettings_ori.ini" COPY /Y "%dstGDK%GameUserSettings.ini" "%dstGDK%GameUserSettings_ori.ini"
    COPY /Y "RealRepo\HOL\Settings\GameUserSettings.ini" "%dstGDK%"
)

ECHO Copying game specific files...
COPY /Y RealRepo\RealVR64.dll dxgi.dll

ECHO Cleaning up...
IF EXIST RealRepo\HZD RMDIR /S /Q RealRepo\HZD
IF EXIST RealRepo\CP2077 RMDIR /S /Q RealRepo\CP2077
IF EXIST RealRepo\ELDEN RMDIR /S /Q RealRepo\ELDEN
IF EXIST RealRepo\DSR RMDIR /S /Q RealRepo\DSR
IF EXIST RealRepo\FF7R RMDIR /S /Q RealRepo\FF7R
IF EXIST RealRepo\GWT RMDIR /S /Q RealRepo\GWT
IF EXIST RealRepo\STRAY RMDIR /S /Q RealRepo\STRAY
IF EXIST RealRepo\GRHEL RMDIR /S /Q RealRepo\GRHEL
IF EXIST RealRepo\SPIDEY RMDIR /S /Q RealRepo\SPIDEY
IF EXIST RealRepo\HOGWARTS RMDIR /S /Q RealRepo\HOGWARTS
IF EXIST RealRepo\AH RMDIR /S /Q RealRepo\AH
IF EXIST RealRepo\ULOTC RMDIR /S /Q RealRepo\ULOTC
GOTO finish


:installAH
ECHO ************************************
ECHO * R.E.A.L. VR mod for Atomic Heart *
ECHO ************************************

ECHO Fixing folder permissions... (note: for the PC Game Pass version, getting an
ECHO Access Denied error that makes processing fail for 1 file is normal here)
ICACLS . /GRANT *S-1-5-32-545:(OI)(CI)F /T /Q

ECHO Working around NVIDIA V-Sync bug...
RealRepo\Vdesync "%base%AtomicHeart-Win64-Shipping.exe"
RealRepo\Vdesync "%base%AtomicHeart-WinGDK-Shipping.exe"

ECHO Installing graphics settings preset...
SET sub=\AtomicHeart\Saved\Config\WindowsNoEditor\
SET subGDK=\AtomicHeart\Saved\Config\WinGDK\
SET "dst=%loc%%sub%"
SET "dstGDK=%loc%%subGDK%"
IF NOT EXIST "%dst%" IF NOT EXIST "%dstGDK%" GOTO neverrun
IF EXIST "%dst%" (
    IF NOT EXIST "%dst%GameUserSettings_ori.ini" COPY /Y "%dst%GameUserSettings.ini" "%dst%GameUserSettings_ori.ini"
    COPY /Y "RealRepo\AH\Settings\GameUserSettings.ini" "%dst%"
)
IF EXIST "%dstGDK%" (
    IF NOT EXIST "%dstGDK%GameUserSettings_ori.ini" COPY /Y "%dstGDK%GameUserSettings.ini" "%dstGDK%GameUserSettings_ori.ini"
    COPY /Y "RealRepo\AH\Settings\GameUserSettings.ini" "%dstGDK%"
)

ECHO Copying game specific files...
COPY /Y RealRepo\RealVR64.dll dxgi.dll

ECHO Cleaning up...
IF EXIST RealRepo\HZD RMDIR /S /Q RealRepo\HZD
IF EXIST RealRepo\CP2077 RMDIR /S /Q RealRepo\CP2077
IF EXIST RealRepo\ELDEN RMDIR /S /Q RealRepo\ELDEN
IF EXIST RealRepo\DSR RMDIR /S /Q RealRepo\DSR
IF EXIST RealRepo\FF7R RMDIR /S /Q RealRepo\FF7R
IF EXIST RealRepo\GWT RMDIR /S /Q RealRepo\GWT
IF EXIST RealRepo\STRAY RMDIR /S /Q RealRepo\STRAY
IF EXIST RealRepo\GRHEL RMDIR /S /Q RealRepo\GRHEL
IF EXIST RealRepo\SPIDEY RMDIR /S /Q RealRepo\SPIDEY
IF EXIST RealRepo\HOGWARTS RMDIR /S /Q RealRepo\HOGWARTS
IF EXIST RealRepo\HOL RMDIR /S /Q RealRepo\HOL
IF EXIST RealRepo\ULOTC RMDIR /S /Q RealRepo\ULOTC
GOTO finish


:installULOTC
ECHO ***************************************************************
ECHO * R.E.A.L. VR mod for Uncharted: Legacy of Thieves Collection *
ECHO ***************************************************************
ECHO(

ECHO Fixing folder permissions...
ICACLS . /GRANT *S-1-5-32-545:(OI)(CI)F /T /Q

ECHO Working around NVIDIA V-Sync bug...
RealRepo\Vdesync "%base%u4.exe"
RealRepo\Vdesync "%base%tll.exe"

ECHO Installing graphics settings preset...
SET sub=\Uncharted4_data\
SET "dst=%base%%sub%"
IF EXIST "%dst%screeninfo.cfg" (
    IF NOT EXIST "%dst%screeninfo_ori.cfg" COPY /Y "%dst%screeninfo.cfg" "%dst%screeninfo_ori.cfg"
) ELSE GOTO neverrun
RealRepo\rxrepl --file "%dst%screeninfo.cfg" --alter --no-backup --options "RealRepo\ULOTC\Settings\option.replace"

ECHO Copying game specific files...
COPY /Y RealRepo\RealVR64.dll dxgi.dll
IF NOT EXIST RealVR.ini COPY /Y RealRepo\ULOTC\RealVR.ini .

ECHO Cleaning up...
IF EXIST RealRepo\HZD RMDIR /S /Q RealRepo\HZD
IF EXIST RealRepo\ELDEN RMDIR /S /Q RealRepo\ELDEN
IF EXIST RealRepo\DSR RMDIR /S /Q RealRepo\DSR
IF EXIST RealRepo\FF7R RMDIR /S /Q RealRepo\FF7R
IF EXIST RealRepo\GWT RMDIR /S /Q RealRepo\GWT
IF EXIST RealRepo\STRAY RMDIR /S /Q RealRepo\STRAY
IF EXIST RealRepo\GRHEL RMDIR /S /Q RealRepo\GRHEL
IF EXIST RealRepo\GROUNDED RMDIR /S /Q RealRepo\GROUNDED
IF EXIST RealRepo\SPIDEY RMDIR /S /Q RealRepo\SPIDEY
IF EXIST RealRepo\HOGWARTS RMDIR /S /Q RealRepo\HOGWARTS
IF EXIST RealRepo\HOL RMDIR /S /Q RealRepo\HOL
IF EXIST RealRepo\AH RMDIR /S /Q RealRepo\AH
GOTO finish


:neverrun
ECHO(
ECHO ERROR: The game appears to never have been run. Run the game at least
ECHO        once to create your user profile, then quit it and try installing
ECHO        the mod again.
ECHO(
:abort
ECHO Aborting RealConfig
GOTO end
:finish
ECHO All done!
:end
PAUSE
:exitnow
